{
  This file was automatically generated on 2019-11-25.

  Delphi/Lazarus Bindings Version 2.1.26

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generators git on tinkerforge.com
}

unit BrickletMultiTouchV2;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter, Math, SyncObjs;

const
  BRICKLET_MULTI_TOUCH_V2_DEVICE_IDENTIFIER = 2129;
  BRICKLET_MULTI_TOUCH_V2_DEVICE_DISPLAY_NAME = 'Multi Touch Bricklet 2.0';

  BRICKLET_MULTI_TOUCH_V2_FUNCTION_GET_TOUCH_STATE = 1;
  BRICKLET_MULTI_TOUCH_V2_FUNCTION_SET_TOUCH_STATE_CALLBACK_CONFIGURATION = 2;
  BRICKLET_MULTI_TOUCH_V2_FUNCTION_GET_TOUCH_STATE_CALLBACK_CONFIGURATION = 3;
  BRICKLET_MULTI_TOUCH_V2_FUNCTION_RECALIBRATE = 5;
  BRICKLET_MULTI_TOUCH_V2_FUNCTION_SET_ELECTRODE_CONFIG = 6;
  BRICKLET_MULTI_TOUCH_V2_FUNCTION_GET_ELECTRODE_CONFIG = 7;
  BRICKLET_MULTI_TOUCH_V2_FUNCTION_SET_ELECTRODE_SENSITIVITY = 8;
  BRICKLET_MULTI_TOUCH_V2_FUNCTION_GET_ELECTRODE_SENSITIVITY = 9;
  BRICKLET_MULTI_TOUCH_V2_FUNCTION_SET_TOUCH_LED_CONFIG = 10;
  BRICKLET_MULTI_TOUCH_V2_FUNCTION_GET_TOUCH_LED_CONFIG = 11;
  BRICKLET_MULTI_TOUCH_V2_FUNCTION_GET_SPITFP_ERROR_COUNT = 234;
  BRICKLET_MULTI_TOUCH_V2_FUNCTION_SET_BOOTLOADER_MODE = 235;
  BRICKLET_MULTI_TOUCH_V2_FUNCTION_GET_BOOTLOADER_MODE = 236;
  BRICKLET_MULTI_TOUCH_V2_FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237;
  BRICKLET_MULTI_TOUCH_V2_FUNCTION_WRITE_FIRMWARE = 238;
  BRICKLET_MULTI_TOUCH_V2_FUNCTION_SET_STATUS_LED_CONFIG = 239;
  BRICKLET_MULTI_TOUCH_V2_FUNCTION_GET_STATUS_LED_CONFIG = 240;
  BRICKLET_MULTI_TOUCH_V2_FUNCTION_GET_CHIP_TEMPERATURE = 242;
  BRICKLET_MULTI_TOUCH_V2_FUNCTION_RESET = 243;
  BRICKLET_MULTI_TOUCH_V2_FUNCTION_WRITE_UID = 248;
  BRICKLET_MULTI_TOUCH_V2_FUNCTION_READ_UID = 249;
  BRICKLET_MULTI_TOUCH_V2_FUNCTION_GET_IDENTITY = 255;

  BRICKLET_MULTI_TOUCH_V2_CALLBACK_TOUCH_STATE = 4;

  BRICKLET_MULTI_TOUCH_V2_TOUCH_LED_CONFIG_OFF = 0;
  BRICKLET_MULTI_TOUCH_V2_TOUCH_LED_CONFIG_ON = 1;
  BRICKLET_MULTI_TOUCH_V2_TOUCH_LED_CONFIG_SHOW_HEARTBEAT = 2;
  BRICKLET_MULTI_TOUCH_V2_TOUCH_LED_CONFIG_SHOW_TOUCH = 3;
  BRICKLET_MULTI_TOUCH_V2_BOOTLOADER_MODE_BOOTLOADER = 0;
  BRICKLET_MULTI_TOUCH_V2_BOOTLOADER_MODE_FIRMWARE = 1;
  BRICKLET_MULTI_TOUCH_V2_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
  BRICKLET_MULTI_TOUCH_V2_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
  BRICKLET_MULTI_TOUCH_V2_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
  BRICKLET_MULTI_TOUCH_V2_BOOTLOADER_STATUS_OK = 0;
  BRICKLET_MULTI_TOUCH_V2_BOOTLOADER_STATUS_INVALID_MODE = 1;
  BRICKLET_MULTI_TOUCH_V2_BOOTLOADER_STATUS_NO_CHANGE = 2;
  BRICKLET_MULTI_TOUCH_V2_BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
  BRICKLET_MULTI_TOUCH_V2_BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
  BRICKLET_MULTI_TOUCH_V2_BOOTLOADER_STATUS_CRC_MISMATCH = 5;
  BRICKLET_MULTI_TOUCH_V2_STATUS_LED_CONFIG_OFF = 0;
  BRICKLET_MULTI_TOUCH_V2_STATUS_LED_CONFIG_ON = 1;
  BRICKLET_MULTI_TOUCH_V2_STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
  BRICKLET_MULTI_TOUCH_V2_STATUS_LED_CONFIG_SHOW_STATUS = 3;

type
  TArray0To12OfBoolean = array [0..12] of boolean;
  TArray0To2OfUInt8 = array [0..2] of byte;
  TArray0To63OfUInt8 = array [0..63] of byte;

  TBrickletMultiTouchV2 = class;
  TBrickletMultiTouchV2NotifyTouchState = procedure(sender: TBrickletMultiTouchV2; const state: TArray0To12OfBoolean) of object;

  /// <summary>
  ///  Capacitive touch sensor for 12 electrodes
  /// </summary>
  TBrickletMultiTouchV2 = class(TDevice)
  private
    touchStateCallback: TBrickletMultiTouchV2NotifyTouchState;
  protected
    procedure CallbackWrapperTouchState(const packet: TByteArray); virtual;
  public
    /// <summary>
    ///  Creates an object with the unique device ID <c>uid</c>. This object can
    ///  then be added to the IP connection.
    /// </summary>
    constructor Create(const uid__: string; ipcon_: TIPConnection);

    /// <summary>
    ///  Returns the current touch state. The state is given as a array of
    ///  bools.
    ///  
    ///  Element 0 to 11 represent the 12 electrodes and element 12 represents
    ///  the proximity.
    ///  
    ///  If an electrode is touched, the corresponding element is *true*. If
    ///  a hand or similar is in proximity to the electrodes, element 12 is
    ///  *true*.
    ///  
    ///  The proximity is activated with a distance of 1-2cm. An electrode
    ///  is already counted as touched if a finger is nearly touching the
    ///  electrode. This means that you can put a piece of paper or foil
    ///  or similar on top of a electrode to build a touch panel with
    ///  a professional look.
    ///  
    ///  If you want to get the value periodically, it is recommended to use the
    ///  <see cref="BrickletMultiTouchV2.TBrickletMultiTouchV2.OnTouchState"/> callback. You can set the callback configuration
    ///  with <see cref="BrickletMultiTouchV2.TBrickletMultiTouchV2.SetTouchStateCallbackConfiguration"/>.
    /// </summary>
    function GetTouchState: TArray0To12OfBoolean; virtual;

    /// <summary>
    ///  The period is the period with which the <see cref="BrickletMultiTouchV2.TBrickletMultiTouchV2.OnTouchState"/> callback
    ///  is triggered periodically. A value of 0 turns the callback off.
    ///  
    ///  If the `value has to change`-parameter is set to true, the callback is only
    ///  triggered after the value has changed. If the value didn't change within the
    ///  period, the callback is triggered immediately on change.
    ///  
    ///  If it is set to false, the callback is continuously triggered with the period,
    ///  independent of the value.
    /// </summary>
    procedure SetTouchStateCallbackConfiguration(const period: longword; const valueHasToChange: boolean); virtual;

    /// <summary>
    ///  Returns the callback configuration as set by
    ///  <see cref="BrickletMultiTouchV2.TBrickletMultiTouchV2.SetTouchStateCallbackConfiguration"/>.
    /// </summary>
    procedure GetTouchStateCallbackConfiguration(out period: longword; out valueHasToChange: boolean); virtual;

    /// <summary>
    ///  Recalibrates the electrodes. Call this function whenever you changed
    ///  or moved you electrodes.
    /// </summary>
    procedure Recalibrate; virtual;

    /// <summary>
    ///  Enables/disables electrodes with a bool array (see <see cref="BrickletMultiTouchV2.TBrickletMultiTouchV2.GetTouchState"/>).
    ///  
    ///  *True* enables the electrode, *false* disables the electrode. A
    ///  disabled electrode will always return *false* as its state. If you
    ///  don't need all electrodes you can disable the electrodes that are
    ///  not needed.
    ///  
    ///  It is recommended that you disable the proximity electrode (element 12) if
    ///  the proximity feature is not needed. This will reduce the amount of
    ///  traffic that is produced by the <see cref="BrickletMultiTouchV2.TBrickletMultiTouchV2.OnTouchState"/> callback.
    ///  
    ///  Disabling electrodes will also reduce power consumption.
    /// </summary>
    procedure SetElectrodeConfig(const enabledElectrodes: array of boolean); virtual;

    /// <summary>
    ///  Returns the electrode configuration, as set by <see cref="BrickletMultiTouchV2.TBrickletMultiTouchV2.SetElectrodeConfig"/>.
    /// </summary>
    function GetElectrodeConfig: TArray0To12OfBoolean; virtual;

    /// <summary>
    ///  Sets the sensitivity of the electrodes. An electrode with a high sensitivity
    ///  will register a touch earlier then an electrode with a low sensitivity.
    ///  
    ///  If you build a big electrode you might need to decrease the sensitivity, since
    ///  the area that can be charged will get bigger. If you want to be able to
    ///  activate an electrode from further away you need to increase the sensitivity.
    ///  
    ///  After a new sensitivity is set, you likely want to call <see cref="BrickletMultiTouchV2.TBrickletMultiTouchV2.Recalibrate"/>
    ///  to calibrate the electrodes with the newly defined sensitivity.
    /// </summary>
    procedure SetElectrodeSensitivity(const sensitivity: byte); virtual;

    /// <summary>
    ///  Returns the current sensitivity, as set by <see cref="BrickletMultiTouchV2.TBrickletMultiTouchV2.SetElectrodeSensitivity"/>.
    /// </summary>
    function GetElectrodeSensitivity: byte; virtual;

    /// <summary>
    ///  Configures the touch LED to be either turned off, turned on, blink in
    ///  heartbeat mode or show the touch state (electrode touched = LED on).
    /// </summary>
    procedure SetTouchLEDConfig(const config: byte); virtual;

    /// <summary>
    ///  Returns the LED configuration as set by <see cref="BrickletMultiTouchV2.TBrickletMultiTouchV2.SetTouchLEDConfig"/>
    /// </summary>
    function GetTouchLEDConfig: byte; virtual;

    /// <summary>
    ///  Returns the error count for the communication between Brick and Bricklet.
    ///  
    ///  The errors are divided into
    ///  
    ///  * ACK checksum errors,
    ///  * message checksum errors,
    ///  * framing errors and
    ///  * overflow errors.
    ///  
    ///  The errors counts are for errors that occur on the Bricklet side. All
    ///  Bricks have a similar function that returns the errors on the Brick side.
    /// </summary>
    procedure GetSPITFPErrorCount(out errorCountAckChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword); virtual;

    /// <summary>
    ///  Sets the bootloader mode and returns the status after the requested
    ///  mode change was instigated.
    ///  
    ///  You can change from bootloader mode to firmware mode and vice versa. A change
    ///  from bootloader mode to firmware mode will only take place if the entry function,
    ///  device identifier and CRC are present and correct.
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    function SetBootloaderMode(const mode: byte): byte; virtual;

    /// <summary>
    ///  Returns the current bootloader mode, see <see cref="BrickletMultiTouchV2.TBrickletMultiTouchV2.SetBootloaderMode"/>.
    /// </summary>
    function GetBootloaderMode: byte; virtual;

    /// <summary>
    ///  Sets the firmware pointer for <see cref="BrickletMultiTouchV2.TBrickletMultiTouchV2.WriteFirmware"/>. The pointer has
    ///  to be increased by chunks of size 64. The data is written to flash
    ///  every 4 chunks (which equals to one page of size 256).
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    procedure SetWriteFirmwarePointer(const pointer: longword); virtual;

    /// <summary>
    ///  Writes 64 Bytes of firmware at the position as written by
    ///  <see cref="BrickletMultiTouchV2.TBrickletMultiTouchV2.SetWriteFirmwarePointer"/> before. The firmware is written
    ///  to flash every 4 chunks.
    ///  
    ///  You can only write firmware in bootloader mode.
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    function WriteFirmware(const data: array of byte): byte; virtual;

    /// <summary>
    ///  Sets the status LED configuration. By default the LED shows
    ///  communication traffic between Brick and Bricklet, it flickers once
    ///  for every 10 received data packets.
    ///  
    ///  You can also turn the LED permanently on/off or show a heartbeat.
    ///  
    ///  If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    /// </summary>
    procedure SetStatusLEDConfig(const config: byte); virtual;

    /// <summary>
    ///  Returns the configuration as set by <see cref="BrickletMultiTouchV2.TBrickletMultiTouchV2.SetStatusLEDConfig"/>
    /// </summary>
    function GetStatusLEDConfig: byte; virtual;

    /// <summary>
    ///  Returns the temperature in °C as measured inside the microcontroller. The
    ///  value returned is not the ambient temperature!
    ///  
    ///  The temperature is only proportional to the real temperature and it has bad
    ///  accuracy. Practically it is only useful as an indicator for
    ///  temperature changes.
    /// </summary>
    function GetChipTemperature: smallint; virtual;

    /// <summary>
    ///  Calling this function will reset the Bricklet. All configurations
    ///  will be lost.
    ///  
    ///  After a reset you have to create new device objects,
    ///  calling functions on the existing ones will result in
    ///  undefined behavior!
    /// </summary>
    procedure Reset; virtual;

    /// <summary>
    ///  Writes a new UID into flash. If you want to set a new UID
    ///  you have to decode the Base58 encoded UID string into an
    ///  integer first.
    ///  
    ///  We recommend that you use Brick Viewer to change the UID.
    /// </summary>
    procedure WriteUID(const uid: longword); virtual;

    /// <summary>
    ///  Returns the current UID as an integer. Encode as
    ///  Base58 to get the usual string version.
    /// </summary>
    function ReadUID: longword; virtual;

    /// <summary>
    ///  Returns the UID, the UID where the Bricklet is connected to,
    ///  the position, the hardware and firmware version as well as the
    ///  device identifier.
    ///  
    ///  The position can be 'a', 'b', 'c' or 'd'.
    ///  
    ///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
    ///  |device_identifier_constant|
    /// </summary>
    procedure GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word); override;

    /// <summary>
    ///  Returns the current touch state, see <see cref="BrickletMultiTouchV2.TBrickletMultiTouchV2.GetTouchState"/> for
    ///  information about the state.
    ///  
    ///  This callback is triggered every time the touch state changes with
    ///  a given period (see <see cref="BrickletMultiTouchV2.TBrickletMultiTouchV2.SetTouchStateCallbackConfiguration"/>)
    /// </summary>
    property OnTouchState: TBrickletMultiTouchV2NotifyTouchState read touchStateCallback write touchStateCallback;
  end;

implementation

constructor TBrickletMultiTouchV2.Create(const uid__: string; ipcon_: TIPConnection);
begin
  inherited Create(uid__, ipcon_);
  apiVersion[0] := 2;
  apiVersion[1] := 0;
  apiVersion[2] := 0;

  responseExpected[BRICKLET_MULTI_TOUCH_V2_FUNCTION_GET_TOUCH_STATE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_MULTI_TOUCH_V2_FUNCTION_SET_TOUCH_STATE_CALLBACK_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_MULTI_TOUCH_V2_FUNCTION_GET_TOUCH_STATE_CALLBACK_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_MULTI_TOUCH_V2_FUNCTION_RECALIBRATE] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_MULTI_TOUCH_V2_FUNCTION_SET_ELECTRODE_CONFIG] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_MULTI_TOUCH_V2_FUNCTION_GET_ELECTRODE_CONFIG] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_MULTI_TOUCH_V2_FUNCTION_SET_ELECTRODE_SENSITIVITY] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_MULTI_TOUCH_V2_FUNCTION_GET_ELECTRODE_SENSITIVITY] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_MULTI_TOUCH_V2_FUNCTION_SET_TOUCH_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_MULTI_TOUCH_V2_FUNCTION_GET_TOUCH_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_MULTI_TOUCH_V2_FUNCTION_GET_SPITFP_ERROR_COUNT] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_MULTI_TOUCH_V2_FUNCTION_SET_BOOTLOADER_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_MULTI_TOUCH_V2_FUNCTION_GET_BOOTLOADER_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_MULTI_TOUCH_V2_FUNCTION_SET_WRITE_FIRMWARE_POINTER] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_MULTI_TOUCH_V2_FUNCTION_WRITE_FIRMWARE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_MULTI_TOUCH_V2_FUNCTION_SET_STATUS_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_MULTI_TOUCH_V2_FUNCTION_GET_STATUS_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_MULTI_TOUCH_V2_FUNCTION_GET_CHIP_TEMPERATURE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_MULTI_TOUCH_V2_FUNCTION_RESET] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_MULTI_TOUCH_V2_FUNCTION_WRITE_UID] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_MULTI_TOUCH_V2_FUNCTION_READ_UID] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_MULTI_TOUCH_V2_FUNCTION_GET_IDENTITY] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;

  callbackWrappers[BRICKLET_MULTI_TOUCH_V2_CALLBACK_TOUCH_STATE] := {$ifdef FPC}@{$endif}CallbackWrapperTouchState;
end;

function TBrickletMultiTouchV2.GetTouchState: TArray0To12OfBoolean;
var request, response: TByteArray; i: longint; stateBits: array [0..1] of byte;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_MULTI_TOUCH_V2_FUNCTION_GET_TOUCH_STATE, 8);
  response := SendRequest(request);
  FillChar(stateBits[0], Length(stateBits) * SizeOf(stateBits[0]), 0);
  for i := 0 to 1 do stateBits[i] := LEConvertUInt8From(8 + (i * 1), response);
  for i := 0 to 12 do result[i] := ((stateBits[Floor(i / 8)] and (1 shl (i mod 8))) <> 0);
end;

procedure TBrickletMultiTouchV2.SetTouchStateCallbackConfiguration(const period: longword; const valueHasToChange: boolean);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_MULTI_TOUCH_V2_FUNCTION_SET_TOUCH_STATE_CALLBACK_CONFIGURATION, 13);
  LEConvertUInt32To(period, 8, request);
  LEConvertBooleanTo(valueHasToChange, 12, request);
  SendRequest(request);
end;

procedure TBrickletMultiTouchV2.GetTouchStateCallbackConfiguration(out period: longword; out valueHasToChange: boolean);
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_MULTI_TOUCH_V2_FUNCTION_GET_TOUCH_STATE_CALLBACK_CONFIGURATION, 8);
  response := SendRequest(request);
  period := LEConvertUInt32From(8, response);
  valueHasToChange := LEConvertBooleanFrom(12, response);
end;

procedure TBrickletMultiTouchV2.Recalibrate;
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_MULTI_TOUCH_V2_FUNCTION_RECALIBRATE, 8);
  SendRequest(request);
end;

procedure TBrickletMultiTouchV2.SetElectrodeConfig(const enabledElectrodes: array of boolean);
var request: TByteArray; i: longint; enabledElectrodesBits: array [0..1] of byte;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_MULTI_TOUCH_V2_FUNCTION_SET_ELECTRODE_CONFIG, 10);
  if (Length(enabledElectrodes) <> 13) then raise EInvalidParameterException.Create('Enabled Electrodes has to be exactly 13 items long');
  FillChar(enabledElectrodesBits[0], Length(enabledElectrodesBits) * SizeOf(enabledElectrodesBits[0]), 0);
  for i := 0 to 12 do if enabledElectrodes[i] then enabledElectrodesBits[Floor(i/8)] := enabledElectrodesBits[Floor(i/8)] or (1 shl (i mod 8));
  for i := 0 to 1 do LEConvertUInt8To(enabledElectrodesBits[i], 8 + (i * 1), request);
  SendRequest(request);
end;

function TBrickletMultiTouchV2.GetElectrodeConfig: TArray0To12OfBoolean;
var request, response: TByteArray; i: longint; enabledElectrodesBits: array [0..1] of byte;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_MULTI_TOUCH_V2_FUNCTION_GET_ELECTRODE_CONFIG, 8);
  response := SendRequest(request);
  FillChar(enabledElectrodesBits[0], Length(enabledElectrodesBits) * SizeOf(enabledElectrodesBits[0]), 0);
  for i := 0 to 1 do enabledElectrodesBits[i] := LEConvertUInt8From(8 + (i * 1), response);
  for i := 0 to 12 do result[i] := ((enabledElectrodesBits[Floor(i / 8)] and (1 shl (i mod 8))) <> 0);
end;

procedure TBrickletMultiTouchV2.SetElectrodeSensitivity(const sensitivity: byte);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_MULTI_TOUCH_V2_FUNCTION_SET_ELECTRODE_SENSITIVITY, 9);
  LEConvertUInt8To(sensitivity, 8, request);
  SendRequest(request);
end;

function TBrickletMultiTouchV2.GetElectrodeSensitivity: byte;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_MULTI_TOUCH_V2_FUNCTION_GET_ELECTRODE_SENSITIVITY, 8);
  response := SendRequest(request);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletMultiTouchV2.SetTouchLEDConfig(const config: byte);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_MULTI_TOUCH_V2_FUNCTION_SET_TOUCH_LED_CONFIG, 9);
  LEConvertUInt8To(config, 8, request);
  SendRequest(request);
end;

function TBrickletMultiTouchV2.GetTouchLEDConfig: byte;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_MULTI_TOUCH_V2_FUNCTION_GET_TOUCH_LED_CONFIG, 8);
  response := SendRequest(request);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletMultiTouchV2.GetSPITFPErrorCount(out errorCountAckChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword);
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_MULTI_TOUCH_V2_FUNCTION_GET_SPITFP_ERROR_COUNT, 8);
  response := SendRequest(request);
  errorCountAckChecksum := LEConvertUInt32From(8, response);
  errorCountMessageChecksum := LEConvertUInt32From(12, response);
  errorCountFrame := LEConvertUInt32From(16, response);
  errorCountOverflow := LEConvertUInt32From(20, response);
end;

function TBrickletMultiTouchV2.SetBootloaderMode(const mode: byte): byte;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_MULTI_TOUCH_V2_FUNCTION_SET_BOOTLOADER_MODE, 9);
  LEConvertUInt8To(mode, 8, request);
  response := SendRequest(request);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletMultiTouchV2.GetBootloaderMode: byte;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_MULTI_TOUCH_V2_FUNCTION_GET_BOOTLOADER_MODE, 8);
  response := SendRequest(request);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletMultiTouchV2.SetWriteFirmwarePointer(const pointer: longword);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_MULTI_TOUCH_V2_FUNCTION_SET_WRITE_FIRMWARE_POINTER, 12);
  LEConvertUInt32To(pointer, 8, request);
  SendRequest(request);
end;

function TBrickletMultiTouchV2.WriteFirmware(const data: array of byte): byte;
var request, response: TByteArray; i: longint;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_MULTI_TOUCH_V2_FUNCTION_WRITE_FIRMWARE, 72);
  if (Length(data) <> 64) then raise EInvalidParameterException.Create('Data has to be exactly 64 items long');
  for i := 0 to Length(data) - 1 do LEConvertUInt8To(data[i], 8 + (i * 1), request);
  response := SendRequest(request);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletMultiTouchV2.SetStatusLEDConfig(const config: byte);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_MULTI_TOUCH_V2_FUNCTION_SET_STATUS_LED_CONFIG, 9);
  LEConvertUInt8To(config, 8, request);
  SendRequest(request);
end;

function TBrickletMultiTouchV2.GetStatusLEDConfig: byte;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_MULTI_TOUCH_V2_FUNCTION_GET_STATUS_LED_CONFIG, 8);
  response := SendRequest(request);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletMultiTouchV2.GetChipTemperature: smallint;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_MULTI_TOUCH_V2_FUNCTION_GET_CHIP_TEMPERATURE, 8);
  response := SendRequest(request);
  result := LEConvertInt16From(8, response);
end;

procedure TBrickletMultiTouchV2.Reset;
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_MULTI_TOUCH_V2_FUNCTION_RESET, 8);
  SendRequest(request);
end;

procedure TBrickletMultiTouchV2.WriteUID(const uid: longword);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_MULTI_TOUCH_V2_FUNCTION_WRITE_UID, 12);
  LEConvertUInt32To(uid, 8, request);
  SendRequest(request);
end;

function TBrickletMultiTouchV2.ReadUID: longword;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_MULTI_TOUCH_V2_FUNCTION_READ_UID, 8);
  response := SendRequest(request);
  result := LEConvertUInt32From(8, response);
end;

procedure TBrickletMultiTouchV2.GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word);
var request, response: TByteArray; i: longint;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_MULTI_TOUCH_V2_FUNCTION_GET_IDENTITY, 8);
  response := SendRequest(request);
  uid := LEConvertStringFrom(8, 8, response);
  connectedUid := LEConvertStringFrom(16, 8, response);
  position := LEConvertCharFrom(24, response);
  for i := 0 to 2 do hardwareVersion[i] := LEConvertUInt8From(25 + (i * 1), response);
  for i := 0 to 2 do firmwareVersion[i] := LEConvertUInt8From(28 + (i * 1), response);
  deviceIdentifier := LEConvertUInt16From(31, response);
end;

procedure TBrickletMultiTouchV2.CallbackWrapperTouchState(const packet: TByteArray);
var state: TArray0To12OfBoolean; i: longint; stateBits: array [0..1] of byte;
begin
  FillChar(stateBits[0], Length(stateBits) * SizeOf(stateBits[0]), 0);
  for i := 0 to 1 do stateBits[i] := LEConvertUInt8From(8 + (i * 1), packet);
  for i := 0 to 12 do state[i] := ((stateBits[Floor(i / 8)] and (1 shl (i mod 8))) <> 0);

  if (Assigned(touchStateCallback)) then begin
    touchStateCallback(self, state);
  end;
end;

end.
